#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 1 

input ENUM_TIMEFRAMES MA_TF=PERIOD_M30;
extern int MA_Period = 20;
extern int MA_ma_shift = 0;
extern ENUM_MA_METHOD MA_method_ = MODE_EMA;
extern ENUM_APPLIED_PRICE MA_applied_price_ = PRICE_CLOSE;
 
double MABuf[];

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init()
{
  SetIndexBuffer(0, MABuf);
  SetIndexStyle(0, DRAW_LINE);
  SetIndexEmptyValue(0, 0.0);
  SetIndexDrawBegin(0, MA_Period);
}

void deinit()
{
}

void start()
{
  int counted_bars = IndicatorCounted();
  if(counted_bars < 0) return;
  if(counted_bars > 0) counted_bars--;

  int limit = Bars-counted_bars;
  limit += MA_TF/Period();

  for (int i=limit; i >= 0; i--)
  {
    int shift = iBarShift(NULL, MA_TF, Time[i], true);
    if (shift == -1) continue;
    
    MABuf[i] = iMA(NULL, MA_TF, MA_Period, MA_ma_shift, MA_method_ , MA_applied_price_, shift);
  }
}